MODULE CRC16;

VAR
	CRC16Tbl :ARRAY 256 OF SET;
	ShftRgstr :SET;
	
(* ######################################################### *)
PROCEDURE	CRC16TblInit*;
	BEGIN
		CRC16Tbl[000] := BITS (00000H); CRC16Tbl[001] := BITS (01189H);
		CRC16Tbl[002] := BITS (02312H); CRC16Tbl[003] := BITS (0329BH);
		CRC16Tbl[004] := BITS (04624H); CRC16Tbl[005] := BITS (057ADH);
		CRC16Tbl[006] := BITS (06536H); CRC16Tbl[007] := BITS (074BFH);
		CRC16Tbl[008] := BITS (08C48H); CRC16Tbl[009] := BITS (09DC1H); 
		CRC16Tbl[010] := BITS (0AF5AH); CRC16Tbl[011] := BITS (0BED3H); 
		CRC16Tbl[012] := BITS (0CA6CH); CRC16Tbl[013] := BITS (0DBE5H); 
		CRC16Tbl[014] := BITS (0E97EH); CRC16Tbl[015] := BITS (0F8F7H);
		CRC16Tbl[016] := BITS (01081H); CRC16Tbl[017] := BITS (00108H); 
		CRC16Tbl[018] := BITS (03393H); CRC16Tbl[019] := BITS (0221AH); 
		CRC16Tbl[020] := BITS (056A5H); CRC16Tbl[021] := BITS (0472CH); 
		CRC16Tbl[022] := BITS (075B7H); CRC16Tbl[023] := BITS (0643EH);
		CRC16Tbl[024] := BITS (09CC9H); CRC16Tbl[025] := BITS (08D40H); 
		CRC16Tbl[026] := BITS (0BFDBH); CRC16Tbl[027] := BITS (0AE52H); 
		CRC16Tbl[028] := BITS (0DAEDH); CRC16Tbl[029] := BITS (0CB64H); 
		CRC16Tbl[030] := BITS (0F9FFH); CRC16Tbl[031] := BITS (0E876H);
		CRC16Tbl[032] := BITS (02102H); CRC16Tbl[033] := BITS (0308BH); 
		CRC16Tbl[034] := BITS (00210H); CRC16Tbl[035] := BITS (01399H); 
		CRC16Tbl[036] := BITS (06726H); CRC16Tbl[037] := BITS (076AFH); 
		CRC16Tbl[038] := BITS (04434H); CRC16Tbl[039] := BITS (055BDH);
		CRC16Tbl[040] := BITS (0AD4AH); CRC16Tbl[041] := BITS (0BCC3H); 
		CRC16Tbl[042] := BITS (08E58H); CRC16Tbl[043] := BITS (09FD1H); 
		CRC16Tbl[044] := BITS (0EB6EH); CRC16Tbl[045] := BITS (0FAE7H);
		CRC16Tbl[046] := BITS (0C87CH); CRC16Tbl[047] := BITS (0D9F5H);
		CRC16Tbl[048] := BITS (03183H); CRC16Tbl[049] := BITS (0200AH); 
		CRC16Tbl[050] := BITS (01291H); CRC16Tbl[051] := BITS (00318H);
		CRC16Tbl[052] := BITS (077A7H); CRC16Tbl[053] := BITS (0662EH); 
		CRC16Tbl[054] := BITS (054B5H); CRC16Tbl[055] := BITS (0453CH);
		CRC16Tbl[056] := BITS (0BDCBH); CRC16Tbl[057] := BITS (0AC42H); 
		CRC16Tbl[058] := BITS (09ED9H); CRC16Tbl[059] := BITS (08F50H); 
		CRC16Tbl[060] := BITS (0FBEFH); CRC16Tbl[061] := BITS (0EA66H); 
		CRC16Tbl[062] := BITS (0D8FDH); CRC16Tbl[063] := BITS (0C974H);
		CRC16Tbl[064] := BITS (04204H); CRC16Tbl[065] := BITS (0538DH); 
		CRC16Tbl[066] := BITS (06116H); CRC16Tbl[067] := BITS (0709FH);
		CRC16Tbl[068] := BITS (00420H); CRC16Tbl[069] := BITS (015A9H); 
		CRC16Tbl[070] := BITS (02732H); CRC16Tbl[071] := BITS (036BBH);
		CRC16Tbl[072] := BITS (0CE4CH); CRC16Tbl[073] := BITS (0DFC5H); 
		CRC16Tbl[074] := BITS (0ED5EH); CRC16Tbl[075] := BITS (0FCD7H); 
		CRC16Tbl[076] := BITS (08868H); CRC16Tbl[077] := BITS (099E1H); 
		CRC16Tbl[078] := BITS (0AB7AH); CRC16Tbl[079] := BITS (0BAF3H);
		CRC16Tbl[080] := BITS (05285H); CRC16Tbl[081] := BITS (0430CH); 
		CRC16Tbl[082] := BITS (07197H); CRC16Tbl[083] := BITS (0601EH); 
		CRC16Tbl[084] := BITS (014A1H); CRC16Tbl[085] := BITS (00528H); 
		CRC16Tbl[086] := BITS (037B3H); CRC16Tbl[087] := BITS (0263AH);
		CRC16Tbl[088] := BITS (0DECDH); CRC16Tbl[089] := BITS (0CF44H); 
		CRC16Tbl[090] := BITS (0FDDFH); CRC16Tbl[091] := BITS (0EC56H); 
		CRC16Tbl[092] := BITS (098E9H); CRC16Tbl[093] := BITS (08960H); 
		CRC16Tbl[094] := BITS (0BBFBH); CRC16Tbl[095] := BITS (0AA72H);
		CRC16Tbl[096] := BITS (06306H); CRC16Tbl[097] := BITS (0728FH); 
		CRC16Tbl[098] := BITS (04014H); CRC16Tbl[099] := BITS (0519DH); 
		CRC16Tbl[100] := BITS (02522H); CRC16Tbl[101] := BITS (034ABH); 
		CRC16Tbl[102] := BITS (00630H); CRC16Tbl[103] := BITS (017B9H);
		CRC16Tbl[104] := BITS (0EF4EH); CRC16Tbl[105] := BITS (0FEC7H); 
		CRC16Tbl[106] := BITS (0CC5CH); CRC16Tbl[107] := BITS (0DDD5H); 
		CRC16Tbl[108] := BITS (0A96AH); CRC16Tbl[109] := BITS (0B8E3H); 
		CRC16Tbl[110] := BITS (08A78H); CRC16Tbl[111] := BITS (09BF1H);
		CRC16Tbl[112] := BITS (07387H); CRC16Tbl[113] := BITS (0620EH); 
		CRC16Tbl[114] := BITS (05095H); CRC16Tbl[115] := BITS (0411CH); 
		CRC16Tbl[116] := BITS (035A3H); CRC16Tbl[117] := BITS (0242AH); 
		CRC16Tbl[118] := BITS (016B1H); CRC16Tbl[119] := BITS (00738H);
		CRC16Tbl[120] := BITS (0FFCFH); CRC16Tbl[121] := BITS (0EE46H); 
		CRC16Tbl[122] := BITS (0DCDDH); CRC16Tbl[123] := BITS (0CD54H); 
		CRC16Tbl[124] := BITS (0B9EBH); CRC16Tbl[125] := BITS (0A862H); 
		CRC16Tbl[126] := BITS (09AF9H); CRC16Tbl[127] := BITS (08B70H);
		CRC16Tbl[128] := BITS (08408H); CRC16Tbl[129] := BITS (09581H); 
		CRC16Tbl[130] := BITS (0A71AH); CRC16Tbl[131] := BITS (0B693H); 
		CRC16Tbl[132] := BITS (0C22CH); CRC16Tbl[133] := BITS (0D3A5H); 
		CRC16Tbl[134] := BITS (0E13EH); CRC16Tbl[135] := BITS (0F0B7H);
		CRC16Tbl[136] := BITS (00840H); CRC16Tbl[137] := BITS (019C9H); 
		CRC16Tbl[138] := BITS (02B52H); CRC16Tbl[139] := BITS (03ADBH); 
		CRC16Tbl[140] := BITS (04E64H); CRC16Tbl[141] := BITS (05FEDH); 
		CRC16Tbl[142] := BITS (06D76H); CRC16Tbl[143] := BITS (07CFFH);
		CRC16Tbl[144] := BITS (09489H); CRC16Tbl[145] := BITS (08500H); 
		CRC16Tbl[146] := BITS (0B79BH); CRC16Tbl[147] := BITS (0A612H);
		CRC16Tbl[148] := BITS (0D2ADH); CRC16Tbl[149] := BITS (0C324H); 
		CRC16Tbl[150] := BITS (0F1BFH); CRC16Tbl[151] := BITS (0E036H);
		CRC16Tbl[152] := BITS (018C1H); CRC16Tbl[153] := BITS (00948H); 
		CRC16Tbl[154] := BITS (03BD3H); CRC16Tbl[155] := BITS (02A5AH); 
		CRC16Tbl[156] := BITS (05EE5H); CRC16Tbl[157] := BITS (04F6CH); 
		CRC16Tbl[158] := BITS (07DF7H); CRC16Tbl[159] := BITS (06C7EH);
		CRC16Tbl[160] := BITS (0A50AH); CRC16Tbl[161] := BITS (0B483H); 
		CRC16Tbl[162] := BITS (08618H); CRC16Tbl[163] := BITS (09791H); 
		CRC16Tbl[164] := BITS (0E32EH); CRC16Tbl[165] := BITS (0F2A7H); 
		CRC16Tbl[166] := BITS (0C03CH); CRC16Tbl[167] := BITS (0D1B5H);
		CRC16Tbl[168] := BITS (02942H); CRC16Tbl[169] := BITS (038CBH); 
		CRC16Tbl[170] := BITS (00A50H); CRC16Tbl[171] := BITS (01BD9H); 
		CRC16Tbl[172] := BITS (06F66H); CRC16Tbl[173] := BITS (07EEFH); 
		CRC16Tbl[174] := BITS (04C74H); CRC16Tbl[175] := BITS (05DFDH);
		CRC16Tbl[176] := BITS (0B58BH); CRC16Tbl[177] := BITS (0A402H); 
		CRC16Tbl[178] := BITS (09699H); CRC16Tbl[179] := BITS (08710H); 
		CRC16Tbl[180] := BITS (0F3AFH); CRC16Tbl[181] := BITS (0E226H); 
		CRC16Tbl[182] := BITS (0D0BDH); CRC16Tbl[183] := BITS (0C134H);
		CRC16Tbl[184] := BITS (039C3H); CRC16Tbl[185] := BITS (0284AH); 
		CRC16Tbl[186] := BITS (01AD1H); CRC16Tbl[187] := BITS (00B58H); 
		CRC16Tbl[188] := BITS (07FE7H); CRC16Tbl[189] := BITS (06E6EH); 
		CRC16Tbl[190] := BITS (05CF5H); CRC16Tbl[191] := BITS (04D7CH);
		CRC16Tbl[192] := BITS (0C60CH); CRC16Tbl[193] := BITS (0D785H); 
		CRC16Tbl[194] := BITS (0E51EH); CRC16Tbl[195] := BITS (0F497H); 
		CRC16Tbl[196] := BITS (08028H); CRC16Tbl[197] := BITS (091A1H); 
		CRC16Tbl[198] := BITS (0A33AH); CRC16Tbl[199] := BITS (0B2B3H);
		CRC16Tbl[200] := BITS (04A44H); CRC16Tbl[201] := BITS (05BCDH); 
		CRC16Tbl[202] := BITS (06956H); CRC16Tbl[203] := BITS (078DFH); 
		CRC16Tbl[204] := BITS (00C60H); CRC16Tbl[205] := BITS (01DE9H); 
		CRC16Tbl[206] := BITS (02F72H); CRC16Tbl[207] := BITS (03EFBH);
		CRC16Tbl[208] := BITS (0D68DH); CRC16Tbl[209] := BITS (0C704H); 
		CRC16Tbl[210] := BITS (0F59FH); CRC16Tbl[211] := BITS (0E416H); 
		CRC16Tbl[212] := BITS (090A9H); CRC16Tbl[213] := BITS (08120H); 
		CRC16Tbl[214] := BITS (0B3BBH); CRC16Tbl[215] := BITS (0A232H);
		CRC16Tbl[216] := BITS (05AC5H); CRC16Tbl[217] := BITS (04B4CH); 
		CRC16Tbl[218] := BITS (079D7H); CRC16Tbl[219] := BITS (0685EH); 
		CRC16Tbl[220] := BITS (01CE1H); CRC16Tbl[221] := BITS (00D68H); 
		CRC16Tbl[222] := BITS (03FF3H); CRC16Tbl[223] := BITS (02E7AH);
		CRC16Tbl[224] := BITS (0E70EH); CRC16Tbl[225] := BITS (0F687H); 
		CRC16Tbl[226] := BITS (0C41CH); CRC16Tbl[227] := BITS (0D595H); 
		CRC16Tbl[228] := BITS (0A12AH); CRC16Tbl[229] := BITS (0B0A3H); 
		CRC16Tbl[230] := BITS (08238H); CRC16Tbl[231] := BITS (093B1H);
		CRC16Tbl[232] := BITS (06B46H); CRC16Tbl[233] := BITS (07ACFH); 
		CRC16Tbl[234] := BITS (04854H); CRC16Tbl[235] := BITS (059DDH); 
		CRC16Tbl[236] := BITS (02D62H); CRC16Tbl[237] := BITS (03CEBH); 
		CRC16Tbl[238] := BITS (00E70H); CRC16Tbl[239] := BITS (01FF9H);
		CRC16Tbl[240] := BITS (0F78FH); CRC16Tbl[241] := BITS (0E606H); 
		CRC16Tbl[242] := BITS (0D49DH); CRC16Tbl[243] := BITS (0C514H); 
		CRC16Tbl[244] := BITS (0B1ABH); CRC16Tbl[245] := BITS (0A022H); 
		CRC16Tbl[246] := BITS (092B9H); CRC16Tbl[247] := BITS (08330H);
		CRC16Tbl[248] := BITS (07BC7H); CRC16Tbl[249] := BITS (06A4EH); 
		CRC16Tbl[250] := BITS (058D5H); CRC16Tbl[251] := BITS (0495CH); 
		CRC16Tbl[252] := BITS (03DE3H); CRC16Tbl[253] := BITS (02C6AH); 
		CRC16Tbl[254] := BITS (01EF1H); CRC16Tbl[255] := BITS (00F78H);
		
	END CRC16TblInit;

(* ######################################################### *)
PROCEDURE	Start*;
	BEGIN
		ShftRgstr := BITS (0FFFFH)
		
	END Start;

(* ######################################################### *)
PROCEDURE	CRC* (d :INTEGER);
	VAR
		dd :SET;
		i :INTEGER;
	BEGIN
		dd := (ShftRgstr * BITS (0FFH)) / (BITS (d) * BITS (0FFH));
		FOR i := 15 TO 8 BY -1 DO
		    IF (i IN ShftRgstr)
		        THEN
			    ShftRgstr := ShftRgstr + {(i - 8)}
			ELSE
			    ShftRgstr := ShftRgstr - {(i - 8)}
		    END;
		END;
		ShftRgstr := CRC16Tbl[(ORD (dd))] / (ShftRgstr * BITS (0FFH));
		
	END CRC;

(* ######################################################### *)
PROCEDURE	Rslt* () :INTEGER;
	BEGIN
		RETURN ORD (ShftRgstr)
	END Rslt;

END CRC16.

