MODULE	PsdRndmSqnc;

VAR
	PsdRndmSqncRgstr :SET;
	
(* ######################################################### *)
PROCEDURE 	Init*;
	BEGIN
		PsdRndmSqncRgstr := {0..15};
	END Init;

(* ######################################################### *)
PROCEDURE	Set* (d :INTEGER);
	BEGIN
		PsdRndmSqncRgstr := BITS (d) * {0..15};
	END Set;

(* ######################################################### *)
PROCEDURE	Rgstr* () :INTEGER;
	BEGIN
		RETURN ORD (PsdRndmSqncRgstr)
	END Rgstr;

(* ######################################################### *)
PROCEDURE	Shifts* (n :INTEGER);
	VAR
		dd :INTEGER;
		s :SET;
		i :INTEGER;

	BEGIN
		dd := ABS (n);
		IF (dd # 0)
		    THEN
			IF (dd > 0FFFFH )
			    THEN
				dd := 0FFFFH
			END;
	
			REPEAT
			      s := PsdRndmSqncRgstr * BITS (0D008H);
			      FOR i := 15 TO 1 BY -1 DO
				  IF ((i - 1) IN PsdRndmSqncRgstr)
				      THEN
					  PsdRndmSqncRgstr := PsdRndmSqncRgstr + {i} 
				      ELSE PsdRndmSqncRgstr := PsdRndmSqncRgstr - {i}
				  END;
			      END;
	
			      IF ((s = BITS (8000H)) OR (s = BITS (4000H)) OR (s = BITS (1000H)) OR
				  (s = BITS (0008H)) OR (s = BITS (5008H)) OR (s = BITS (9008H)) OR
				  (s = BITS (0C008H)) OR (s = BITS (0D000H)))
				  THEN
				      PsdRndmSqncRgstr := PsdRndmSqncRgstr + {0}
				  ELSE
				      PsdRndmSqncRgstr := PsdRndmSqncRgstr - {0}
			      END;
			      dd := dd - 1;
			UNTIL (dd = 0);
		END;
	
	END Shifts;

END PsdRndmSqnc.
